<?php

/*
 * Boilerplate
 */

declare(strict_types=1);

namespace Univie\Basisklassifikation;

if (!defined('\\ABSPATH')) {
    exit();
}


/*
 * Upload a JSKOS file from a URL.
 */
class JSKOSUploadInput extends AbstractInput
{
    public string $type = 'file';

    public function process(): mixed
    {
        ini_set('max_execution_time', MAX_EXECUTION_TIME);

        $file = $_FILES[$this->name];
        if ($file === null) {
            return false;
        }

        $fname = $file['tmp_name'];
        if ($fname === null || $fname === '') {
            return false;
        }

        $fh = new \SplFileObject($fname);

        foreach ($fh as $line) {
            if (!preg_match('/^\s*$/', $line)) {
                $class = Klasse::from_json($line);
                $class->update_terms(insert: true);
            }
        }

        admin_notify(
            'success',
            'Loaded %s lines from %s.',
            count($fh),
            $file['name']
        );

        return true;
    }
}
